<template>
    <div >
        <form @submit.prevent="EditarNota(nota)" v-if="editarActivo">
            <h3>Editar Tareas</h3>
            <input type="text"  placeholder="Nombre" v-model="nota.nombre">
            <input type="text" placeholder="Descripcion" v-model="nota.dexcripcion">
            <button type="submit">Guardar</button>
            <button type="submit"
            @click="cancelar">Cancelar</button>

        </form>
        <!--formulario aditar -->
         <form @submit.prevent="agregar" v-else>
            <h3>Agragar Tareas</h3>
            <input type="text"  placeholder="Nombre" v-model="nota.nombre">
            <input type="text" placeholder="Descripcion" v-model="nota.dexcripcion">
            <button type="submit">Agregar</button>

        </form>
        <hr>
        <h4>lista de tareas</h4>
        <ul>
            <li v-for="(item, index) in notas" :key="index">
                <p>{{item.nombre}}</p>
                <p>{{item.dexcripcion}}</p>
                <span>
                    {{item.updated_at}}
                </span>
                <button
                    @click="eliminarNota(item, index)">Terminar
                </button>
                <button
                    @click="editarFormulario(item)">Editar
                </button>
            </li> 
        </ul>
    </div>
</template>

<script>
    export default {
        data(){
            return{
                notas:[],
                nota:{
                    nombre:'',
                    dexcripcion:''
                },
                editarActivo:false
            }
        },
        created(){
            axios.get('/not')
            .then(res=>{
                this.notas=res.data;
            });
        },
        methods: {
            agregar(){
                
                if(this.nota.nombre.trim() === '' || this.nota.dexcripcion.trim() === ''){
                    alert('Debes completar todos los campos antes de guardar');
                    return;
                }
                //console.log(this.nota.nombre, this.nota.dexcripcion);
                const parametros={
                    nombre:this.nota.nombre, 
                    dexcripcion:this.nota.dexcripcion
                } ; 
                                              
                axios.post('/agregar', parametros)
                .then(res=>{
                    this.notas.push(res.data)
                    //console.log(parametros);
                    this.nota.nombre='';
                    this.nota.dexcripcion='';
                }); 
            },
            eliminarNota(item, index){
                axios.delete(`/eliminar/${item.id}`)
                .then(()=>{
                    this.notas.splice(index, 1);
                });
            },
            editarFormulario(item){
                this.editarActivo=true;
                this.nota.nombre=item.nombre;
                this.nota.dexcripcion=item.dexcripcion;
                this.nota.id=item.id;

            },
            EditarNota(item){
                 const parametros={
                    nombre:item.nombre, 
                    dexcripcion:item.dexcripcion
                };
                axios.put(`/actualisar/${item.id}`, parametros)
                .then(res=>{
                   const index=this.notas.findIndex
                   (notaBuscar=>notaBuscar.id===res.data.id)
                   this.notas[index]=res.data.id;
                });
            },
            cencelar(){
                editarActivo:false;
                this.nota.nombre='';
                    this.nota.dexcripcion='';
            }
        }
    }
</script>